#ifndef NAPSA_CONFIG_H
#define NAPSA_CONFIG_H

/* $Id: config.h,v 3.4 1994/05/14 14:02:28 ppessi Exp $
 *
 * config.h --- Configuration for Napsaterm
 *
 * Author: ppessi <Pekka.Pessi@hut.fi>
 *
 * Copyright (c) 1993 AmiTCP/IP Group, <amitcp-group@hut.fi>
 *                    Helsinki University of Technology, Finland.
 *                    All rights reserved.
 *
 * Created      : Tue May 18 15:05:14 1993 ppessi
 * Last modified: Sat May 14 16:06:01 1994 ppessi
 *
 * $Log: config.h,v $
 * Revision 3.4  1994/05/14  14:02:28  ppessi
 * Added optional tektronix 4010 emulation to configuration
 *
 * Revision 3.3  1994/05/14  11:04:21  ppessi
 * Added Telnet
 *
 * Revision 3.2  1994/02/25  16:08:03  ppessi
 * Disabled DNET; enabled getpwent()
 *
 * Revision 3.1  1994/01/07  22:50:50  ppessi
 * Version 3 beta
 */

/* Uncomment if you don't want to have tektronix 4010 emulation */
#define TEKTRONICS 1

/* Uncomment latter if you want to have serial.device interface */
/* #define USE_SERIAL 0 */
#define USE_SERIAL 1

/* Uncomment latter if you want to have dnet interface */
#define USE_DNET 0 
/* #define USE_DNET 1 */

/* Uncomment latter if you want to have DOS file IO interface */
/* #define USE_STDIO 0 */
#define USE_STDIO 1

/* Uncomment latter if you want to have rlogin protocol interface */
/* #define USE_RLOGIN 0 */
#define USE_RLOGIN 1

/* Uncomment latter if you want to have telnet protocol interface */
/* #define USE_TELNET 0 */
#define USE_TELNET 1

/* Uncomment if you want to use non-blocking socket IO with rlogin */
#define USE_FIONBIO 1

/* Uncomment if we have a working getuid() and getpwuid */
#define USE_GETUID 1

/*
 * Compiler dependent stuff
 *
 * - the shared library interface defines
 * - linker interface
 */

/* Uncomment if you want use clib includes and amiga.lib stubs */
/* #define USE_CLIB 1 */

#if defined(__SASC)
#if !defined(USE_CLIB)
#define USE_PRAGMAS 1
#endif
#define USE_CHIP    1		/* we have __chip keyword */
#define INLINE __inline
#define CHIP __chip
#define ASM  __asm		/* registerized arguments */

#elif defined(__GNUC__)
#error GNU CC is not fully supported 
#if !defined(USE_CLIB)
#define USE_INLINE 1
#endif
#undef USE_CHIP			/* No __chip keyword */
#define INLINE __inline
#define CHIP
#define ASM  __asm

#else
#define USE_CLIB
#define INLINE
#undef  USE_CHIP
#define CHIP
#define ASM
#endif
#endif
